// Ionic Starter App
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'ionic-citydata', 'ionic-citypicker'], function ($httpProvider) {
        // Use x-www-form-urlencoded Content-Type
        $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
        /**
         * The workhorse; converts an object to x-www-form-urlencoded serialization.
         * @param {Object} obj
         * @return {String}
         */
        var param = function (obj) {
            var query = '', name, value, fullSubName, subName, subValue, innerObj, i;
            for (name in obj) {
                value = obj[name];
                if (value instanceof Array) {
                    for (i = 0; i < value.length; ++i) {
                        subValue = value[i];
                        fullSubName = name + '[' + i + ']';
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + '&';
                    }
                }
                else if (value instanceof Object) {
                    for (subName in value) {
                        subValue = value[subName];
                        fullSubName = name + '[' + subName + ']';
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + '&';
                    }
                }
                else if (value !== undefined && value !== null)
                    query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
            }
            return query.length ? query.substr(0, query.length - 1) : query;
        };
        // Override $http service's default transformRequest
        $httpProvider.defaults.transformRequest = [function (data) {
            return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
        }];


    })

    .run(function ($ionicPlatform) {
        $ionicPlatform.ready(function () {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(true);
            }
            if (window.StatusBar) {
                // org.apache.cordova.statusbar required
                StatusBar.styleDefault();
            }
        });

    })

    .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $ionicConfigProvider.platform.ios.tabs.style('standard');
        $ionicConfigProvider.platform.ios.tabs.position('bottom');
        $ionicConfigProvider.platform.android.tabs.style('standard');
        $ionicConfigProvider.platform.android.tabs.position('bottom');
        $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
        $ionicConfigProvider.platform.android.navBar.alignTitle('center');
        $ionicConfigProvider.platform.ios.backButton.previousTitleText(' ').icon('ion-ios-arrow-thin-left');
        $ionicConfigProvider.platform.android.backButton.previousTitleText(' ').icon('ion-android-arrow-back');
        $ionicConfigProvider.platform.ios.views.transition('ios');
        $ionicConfigProvider.platform.android.views.transition('android');
        $ionicConfigProvider.backButton.previousTitleText(false);

        $stateProvider
        /* .state('tab', {
         url: '/tab',
         cache:false,
         abstract: true,
         templateUrl: 'templates/tabs.html'
         })*/
        // 我  个人中心
            .state("mine", {
                url: "/mine",
                cache: false,
                abstract: true,
                templateUrl: 'templates/tabs.html',
                controller: 'tabCtrl'
            })
			 .state("others", {
                url: "/others",
                abstract: true,
                template: '<ion-nav-view></ion-nav-view>',
                controller:"otherCtrl"
            })
		//发现
            .state("find", {
                url: "/find",
                cache: false,
                abstract: true,
                templateUrl: 'templates/tabs.html',
                controller: 'tabCtrl'
            })
		//公会活动
            .state("union", {
                url: "/union",
                cache: false,
                abstract: true,
                templateUrl: 'templates/tabs.html',
                controller: 'tabCtrl'
            })

        //本区活动
            .state("block", {
                url: "/block",
                cache: false,
                abstract: true,
                templateUrl: 'templates/tabs.html',
                controller: 'tabCtrl'
            })
            //世界活动
            .state("word", {
                url: "/word",
                cache: false,
                abstract: true,
                templateUrl: 'templates/tabs.html',
                controller: 'tabCtrl'
            })

            .state("user", {
                url: "/user",
                cache: false,
                abstract: true,
                templateUrl: 'templates/tabs.html',
                controller: 'tabCtrl'
            })
//我开始
            //我  个人中心开始
            .state('mine.mine', {
                url: '/mine',
                cache: true,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/personCenter.html',
                        controller: 'personCenterController'
                    }
                }
            })
            //注册
            .state('user.register', {
                url: '/register',
                cache: true,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/register.html',
                        controller: 'userRegisterController'
                    }
                }
            })
			//登录
			.state('user.login', {
                url: '/login',
                cache: true,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/dl.html',
                        controller: 'loginController'
                    }
                }
            })
            //意见反馈
            .state('mine.yjfk', {
                url: '/yjfk',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/yjfq.html',
                        controller: 'suggestController'
                    }
                }
            })

            //会员类型介绍
            .state('mine.hylxjs', {
                url: '/hylxjs',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/hylxjs.html',
                        controller: 'styleIntroduceController'
                    }
                }
            })
            //个人资料
            .state('mine.grzh', {
                url: '/grzh',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/grzh.html',
                        controller: 'personinfoController'
                    }
                }
            })

            //修改密码
            .state('mine.xgmm', {
                url: '/xgmm',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/xgmm.html',
                        controller: 'xgmmController'
                    }
                }
            })

            //公会选择
            .state('mine.jrgh', {
                url: '/jrgh',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/jrgh.html',
                        controller: 'xzghCtrl'
                    }
                }
            })

            //公会申请编辑
            .state('mine.tjsq', {
                url: '/tjsq/:id',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/tjsq.html',
                        controller: 'ghsqCtrl'
                    }
                }
            })

            //创建公会
            .state('mine.cjgh', {
                url: '/cjgh',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/createunion.html',
                        controller: 'newunionCtrl'
                    }
                }
            })

            //创建公会
            .state('mine.sczp', {
                url: '/sczp',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/sczp.html',
                        controller: 'spzpCtrl'
                    }
                }
            })

            //月卡管理
            .state('mine.ykgl', {
                url: '/ykgl',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/ykgl.html',
                        controller: 'ykglCtrl'
                    }
                }
            })

            //消息中心
            .state('mine.xxzx', {
                url: '/xxzx',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/xxzx.html',
                        controller: 'xxzxCtrl'
                    }
                }
            })

            //我的帖子
            .state('mine.wdtz', {
                url: '/wdtz',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/wdtz.html',
                        controller: 'wdtzCtrl'
                    }
                }
            })
            //会长审批
            .state('mine.hzsp', {
                url: '/hzsp',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/hzsp.html',
                        controller: 'hzspCtrl'
                    }
                }
            })
            //我的招聘
            .state('mine.wdzp', {
                url: '/wdzp',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/wdzp.html',
                        controller: 'wdzpCtrl'
                    }
                }
            })

            //修改帖子
            .state('mine.editpost', {
                url: '/editpost/:id',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/editpost.html',
                        controller: 'editpostController'
                    }
                }
            })
            //修改招聘信息
            .state('mine.editzp', {
                url: '/editzp/:id',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/editzp.html',
                        controller: 'editzpController'
                    }
                }
            })
            //V值测试
            .state('mine.yxvzcs', {
                url: '/yxvzcs',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/yxvzcs.html',
                        controller: 'testController'
                    }
                }
            })

            //付款页面
            .state('mine.fk', {
                url: '/fk',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/fk.html',
                        controller: 'fkCtrl'
                    }
                }
            })

            //忘记密码
            .state('user.wjmm', {
                url: '/wjmm',
                cache: false,
                views: {
                        'mine': {
                        templateUrl: 'templates/mine/wjmm.html',
                        controller: 'lookforpsdController'
                    }
                }
            })

            //查看信息详细
            .state('mine.readmsg', {
                url: '/readmsg',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/readmsg.html',
                        controller: 'readmsgCtrl'
                    }
                }
            })
            //jjc  数据库 中心
            .state('mine.jjcCenter', {
                url: '/jjcCenter',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/jjcCenter.html',
                        controller: 'jjcCenterCtrl'
                    }
                }
            })
            //jjc  使用规则
            .state('mine.jjcRule', {
                url: '/jjcRule',
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/jjcRule.html',
                        controller: 'jjcCenterCtrl'
                    }
                }
            })
            //jjc  创建
            .state('mine.create', {
                url: '/create',
                cache: true,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/jjcCreate.html',
                        controller: 'createCtrl'
                    }
                }
            })
            //jjc  防守英雄
            .state('mine.jjcdefensive', {
                url: '/jjcdefensive',
                cache: true,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/jjcdefensive.html',
                        controller: 'createCtrl'
                    }
                }
            })
            //jjc  进攻英雄
            .state('mine.jjcattack', {
                url: '/jjcattack',
                cache: true,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/jjcattack.html',
                        controller: 'createCtrl'
                    }
                }
            })
            //jjc  使用
            .state('mine.useJjc', {
                url: '/useJjc/:type',//1个人 2公会 3区  4世界
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/useJjc.html',
                        controller: 'useJjcCtrl'
                    }
                }
            })
            //jjc  使用
            .state('mine.useHero', {
                url: '/useHero/:id',//1个人 2公会 3区  4世界
                cache: false,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/useHero.html',
                        controller: 'useJjcCtrl'
                    }
                }
            })

            .state('mine.unionPostDetail', {
                url: '/unionPostDetail/:newsId/:type',
                cache: true,
                views: {
                    'mine': {
                        templateUrl: 'templates/union/unionPostDetail.html',
                        controller: 'unionPostDetailController'
                    }
                }
            })

            .state('mine.answerPost', {
                url: '/answerPost/:newsId/:type/:floor/:id/:num',
                cache: true,
                views: {
                    'mine': {
                        templateUrl: 'templates/union/answerPost.html',
                        controller: 'answerPostController'
                    }
                }
            })

            .state('mine.JobDetail', {
                url: '/JobDetail/:id/:postId',// id 1区 2公会 postId 帖子的id
                cache: true,
                views: {
                    'mine': {
                        templateUrl: 'templates/block/JobDetail.html',
                        controller: 'JobDetailController'
                    }
                }
            })

            //发布信息 1 发布当日要闻 2发布公会公告 3发布工会帖子
            .state('mine.setUnionPost', {
                url: '/setUnionPost/:type/:id',
                cache: true,
                views: {
                    'mine': {
                        templateUrl: 'templates/union/setUnionPost.html',
                        controller: 'setUnionMessageController'
                    }
                }
            })

    //我结束
    //公会开始
          //公会活动
            .state('union.unionCenter', {
                url: '/unionCenter',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/unionCenter.html',
                        controller: 'unionController'
                    }
                }
            })
            //当日要闻列表
            .state('union.dayNewsList', {
                url: '/dayNewsList',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/dayNewsList.html',
                        controller: 'unionController'
                    }
                }
            })
            //当日要闻详情
            .state('union.dayNewsDetail', {
                url: '/dayNewsDetail/:id',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/dayNewsDetail.html',
                        controller: 'newsDetailController'
                    }
                }
            })
            //回复当日要闻
            .state('union.answerNews', {
                url: '/answerNews/:newsId',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/answerNews.html',
                        controller: 'answerNewsController'
                    }
                }
            })
            //当日要闻楼层回复
            .state('union.answerFloor', {
                url: '/answerFloor/:newsId/:floorId',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/answerFloor.html',
                        controller: 'answerFloorController'
                    }
                }
            })
            //当日要闻回复用户
            .state('union.answerPerson', {
                url: '/answerPerson/:newsId/:floorId/:id',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/answerPerson.html',
                        controller: 'answerPersonController'
                    }
                }
            })
            //公会公告列表
            .state('union.announcement', {
                url: '/announcement',
                cache: false,
                views: {
                    'union': {
                        templateUrl: 'templates/union/announcement.html',
                        controller: 'announcementController'
                    }
                }
            })
            //公会公告详情
            .state('union.noticeDetail', {
                url: '/noticeDetail/:newsId',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/noticeDetail.html',
                        controller: 'noticeDetailController'
                    }
                }
            })
            //公会删除
            .state('union.repair', {
                url: '/repair/:id',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/repair.html',
                        controller: 'noticeDetailController'
                    }
                }
            })
            //公会贴吧 帖子详情
            .state('union.unionPostDetail', {
                url: '/unionPostDetail/:newsId/:type',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/unionPostDetail.html',
                        controller: 'unionPostDetailController'
                    }
                }
            })
            //公会贴吧 帖子列表
            .state('union.unionPost', {
                url: '/unionPost',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/unionPost.html',
                        controller: 'unionPostController'
                    }
                }
            })

            //回复帖子
            .state('union.answerPost', {
                url: '/answerPost/:newsId/:type/:floor/:id/:num',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/answerPost.html',
                        controller: 'answerPostController'
                    }
                }
            })

            //发当日要闻
            .state('union.setNews', {
                url: '/setNews/:type',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/setNews.html',
                        controller: 'setUnionMessageController'
                    }
                }
            })
            //发布公会信息 1 发布当日要闻 2发布公会公告 3发布工会帖子
            .state('union.setUnionPost', {
                url: '/setUnionPost/:type/:id',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/setUnionPost.html',
                        controller: 'setUnionMessageController'
                    }
                }
            })
            //私信 type 1公会2区3世界
            .state('union.setLetter', {
                url: '/setLetter/:type/:user/:newsId/:link/:state',// type 1公会 2区 3世界 user 被私信人 newsid 返回 时候的信息id link 链接 state 1发送 2回复
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/setLetter.html',
                        controller: 'setLetterController'
                    }
                }
            })
            //公会私信
            .state('union.unionLetter', {
                url: '/unionLetter/:index',
                cache: false,
                views: {
                    'union': {
                        templateUrl: 'templates/union/unionLetter.html',
                        controller: 'unionLetterController'
                    }
                }
            })
            //私信详情
            .state('union.letterDetail', {
                url: '/letterDetail/:letterId/:id',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/letterDetail.html',
                        controller: 'letterDetailController'
                    }
                }
            })
            //公会vip
            .state('union.unionVip', {
                url: '/unionVip',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/unionVip.html',
                        controller: 'unionVipController'
                    }
                }
            })
            //公会成员详细
            .state('union.unionVipDetail', {
                url: '/unionVipDetail',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/unionVipDetail.html',
                        controller: 'unionLetterController'
                    }
                }
            })
            //公会梦境视频
            .state('union.unionVideo', {
                url: '/unionVideo',
                cache: false,
                views: {
                    'union': {
                        templateUrl: 'templates/union/unionVideo.html',
                        controller: 'unionVideoController'
                    }
                }
            })
            //公会梦境高分视频 视频详细
            .state('union.unionVideoDetail', {
                url: '/unionVideoDetail/:videoId',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/unionVideoDetail.html',
                        controller: 'videoDetailController'
                    }
                }
            })
            //公会梦境高分视频 发布视频
            .state('union.setVideo', {
                url: '/setVideo',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/setVideo.html',
                        controller: 'setVideoController'
                    }
                }
            })
            //公会梦境高分视频 选择boss
            .state('union.chooseBoss', {
                url: '/chooseBoss',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/chooseBoss.html',
                        controller: 'setVideoController'
                    }
                }
            })
            //公会梦境高分视频 选择英雄
            .state('union.chooseHero', {
                url: '/chooseHero',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/chooseHero.html',
                        controller: 'setVideoController'
                    }
                }
            })
            //公会梦境高分视频 视频规则
            .state('union.rule', {
                url: '/rule',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/rule.html',
                        controller: 'ruleController'
                    }
                }
            })
            //本区贴吧 帖子修改
            .state('union.postRepair', {
                url: '/postRepair/:id/:detail',
                cache: true,
                views: {
                    'union': {
                        templateUrl: 'templates/union/postRepair.html',
                        controller: 'unionPostDetailController'
                    }
                }
            })
//公会结束

//区组活动开始
            //本区活动中心
            .state('block.blockCenter', {
                url: '/blockCenter',
                cache: true,
                views: {
                    'block': {
                        templateUrl: 'templates/block/blockCenter.html',
                        controller: 'blockController'
                    }
                }
            })
            //修改招聘信息
            .state('block.editzp', {
                url: '/editzp/:id',
                cache: false,
                views: {
                    'block': {
                        templateUrl: 'templates/mine/editzp.html',
                        controller: 'editzpController'
                    }
                }
            })
            //本区贴吧
            .state('block.blockPost', {
                url: '/blockPost',
                cache: true,
                views: {
                    'block': {
                        templateUrl: 'templates/block/blockPostList.html',
                        controller: 'blockPostListController'
                    }
                }
            })

            //本区贴吧 帖子详情
            .state('block.unionPostDetail', {
                url: '/unionPostDetail/:newsId/:type',
                cache: true,
                views: {
                    'block': {
                        templateUrl: 'templates/union/unionPostDetail.html',
                        controller: 'unionPostDetailController'
                    }
                }
            })
            //本区贴吧 帖子修改
            .state('block.postRepair', {
                url: '/postRepair/:id/:detail',
                cache: true,
                views: {
                    'block': {
                        templateUrl: 'templates/union/postRepair.html',
                        controller: 'unionPostDetailController'
                    }
                }
            })

            //回复帖子
            .state('block.answerPost', {
                url: '/answerPost/:newsId/:type/:floor/:id/:num',
                cache: true,
                views: {
                    'block': {
                        templateUrl: 'templates/union/answerPost.html',
                        controller: 'answerPostController'
                    }
                }
            })

            //发布信息 1 发布当日要闻 2发布公会公告 3发布工会帖子
            .state('block.setUnionPost', {
                url: '/setUnionPost/:type/:id',
                cache: true,
                views: {
                    'block': {
                        templateUrl: 'templates/union/setUnionPost.html',
                        controller: 'setUnionMessageController'
                    }
                }
            })
            //本区私信
            .state('block.blockLetter', {
                url: '/blockLetter',
                cache: true,
                views: {
                    'block': {
                        templateUrl: 'templates/block/blockLetter.html',
                        controller: 'blockLetterController'
                    }
                }
            })

            //私信 type 1公会2区3世界
            .state('block.setLetter', {
                url: '/setLetter/:type/:user/:newsId/:link/:state',
                cache: true,
                views: {
                    'block': {
                        templateUrl: 'templates/union/setLetter.html',
                        controller: 'setLetterController'
                    }
                }
            })
            //私信详情
            .state('block.letterDetail', {
                url: '/letterDetail/:letterId/:id',
                cache: true,
                views: {
                    'block': {
                        templateUrl: 'templates/union/letterDetail.html',
                        controller: 'letterDetailController'
                    }
                }
            })
            //本区招聘
            .state('block.blockJob', {
                url: '/blockJob/:id',
                cache: true,
                views: {
                    'block': {
                        templateUrl: 'templates/block/blockJob.html',
                        controller: 'blockJobController'
                    }
                }
            })

            //招聘详情
            .state('block.JobDetail', {
                url: '/JobDetail/:id/:postId',// id 1区 2公会 postId 帖子的id
                cache: false,
                views: {
                    'block': {
                        templateUrl: 'templates/block/JobDetail.html',
                        controller: 'JobDetailController'
                    }
                }
            })
            //发布招聘信息
            .state('block.recruitment', {
                url: '/recruitment/:id',// id 1区 2公会
                cache: true,
                views: {
                    'block': {
                        templateUrl: 'templates/block/recruitment.html',
                        controller: 'recruitmentController'
                    }
                }
            })
//区组活动结束
//世界活动开始

            //世界活动首页
            .state('word.wordCenter', {
                url: '/wordCenter',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/wordCenter.html',
                        controller: 'wordCenterController'
                    }
                }
            })
            //世界招聘
            .state('word.wordJob', {
                url: '/wordJob/:id',// id 1区 2公会
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/wordJob.html',
                        controller: 'wordJobController'
                    }
                }
            })
            //招聘详情
            .state('word.JobDetail', {
                url: '/JobDetail/:id/:postId',// id 1区 2公会 postId 帖子的id
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/block/JobDetail.html',
                        controller: 'JobDetailController'
                    }
                }
            })
            //发布招聘信息
            .state('word.recruitment', {
                url: '/recruitment/:id',// id 1区 2公会
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/block/recruitment.html',
                        controller: 'recruitmentController'
                    }
                }
            })
            //世界贴吧
            .state('word.wordPost', {
                url: '/wordPost',// id 1区 2公会
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/wordPost.html',
                        controller: 'wordPostController'
                    }
                }
            })
            //发布信息 1 发布当日要闻 2发布公会公告 3发布工会帖子
            .state('word.setUnionPost', {
                url: '/setUnionPost/:type/:id',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/union/setUnionPost.html',
                        controller: 'setUnionMessageController'
                    }
                }
            })
            //世界贴吧 帖子详情
            .state('word.unionPostDetail', {
                url: '/unionPostDetail/:newsId/:type',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/union/unionPostDetail.html',
                        controller: 'unionPostDetailController'
                    }
                }
            })
            //回复帖子
            .state('word.answerPost', {
                url: '/answerPost/:newsId/:type/:floor/:id/:num',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/union/answerPost.html',
                        controller: 'answerPostController'
                    }
                }
            })
            //私信 type 1公会2区3世界
            .state('word.setLetter', {
                url: '/setLetter/:type/:user/:newsId/:link/:state',// type 1公会 2区 3世界 user 被私信人 newsid 返回 时候的信息id link 链接 state 1发送 2回复
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/union/setLetter.html',
                        controller: 'setLetterController'
                    }
                }
            })
            //世界私信列表
            .state('word.wordLetter', {
                url: '/wordLetter',// type 1公会 2区 3世界 user 被私信人 newsid 返回 时候的信息id link 链接 state 1发送 2回复
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/wordLetter.html',
                        controller: 'wordLetterController'
                    }
                }
            })
            //私信详情
            .state('word.letterDetail', {
                url: '/letterDetail/:letterId/:id',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/union/letterDetail.html',
                        controller: 'letterDetailController'
                    }
                }
            })
            //陌生公会查询
            .state('word.strange', {
                url: '/strange',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/strange.html',
                        controller: 'strangeController'
                    }
                }
            })
            //陌生公会会长私信
            .state('word.strangeLetter', {
                url: '/strangeLetter/:userId',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/strangeLetter.html',
                        controller: 'strangeLetterController'
                    }
                }
            })
            //商业街区 帖子列表
            .state('word.shopStreet', {
                url: '/shopStreet',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/shopStreet.html',
                        controller: 'shopStreetController'
                    }
                }
            })
            //商业街区 帖子详情
            .state('word.shopDetail', {
                url: '/shopDetail/:id',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/shopDetail.html',
                        controller: 'shopDetailController'
                    }
                }
            })
            //商业街区 发帖子
            .state('word.setShopPost', {
                url: '/setShopPost',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/setShopPost.html',
                        controller: 'setShopPostController'
                    }
                }
            })
            //商业街区 私信
            .state('word.shopLetter', {
                url: '/shopLetter/:userId/:id',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/shopLetter.html',
                        controller: 'shopLetterController'
                    }
                }
            })
            //世界梦境高分视频 类别列表
            .state('word.wordVideo', {
                url: '/wordVideo',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/wordVideo.html',
                        controller: 'wordVideoController'
                    }
                }
            })
            //世界梦境高分视频 视频列表
            .state('word.videoList', {
                url: '/videoList/:videoId',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/videoList.html',
                        controller: 'videoListController'
                    }
                }
            })
            //世界梦境高分视频 视频列表
            .state('word.videoDetail', {
                url: '/videoDetail/:videoId',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/videoDetail.html',
                        controller: 'videoDetailController'
                    }
                }
            })
            //游戏帐号转让
            .state('word.sell', {
                url: '/sell/:type',
                cache: false,
                views: {
                    'word': {
                        templateUrl: 'templates/word/sell.html',
                        controller: 'sellController'
                    }
                }
            })
            //游戏帐号转让 详情
            .state('word.sellDetail', {
                url: '/sellDetail/:id',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/sellDetail.html',
                        controller: 'sellDetailController'
                    }
                }
            })
            //游戏帐号转让 私信
            .state('word.sellLetter', {
                url: '/sellLetter/:userId/:id',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/word/sellLetter.html',
                        controller: 'sellLetterController'
                    }
                }
            })
            //本区贴吧 帖子修改
            .state('word.postRepair', {
                url: '/postRepair/:id/:detail',
                cache: true,
                views: {
                    'word': {
                        templateUrl: 'templates/union/postRepair.html',
                        controller: 'unionPostDetailController'
                    }
                }
            })
//世界活动结束
            //发现
            .state('find.find', {
                url: '/find',
                cache: true,
                views: {
                    'find': {
                        templateUrl: 'templates/find/fx.html',
                        controller: 'findCtrl'
                    }
                }
            })

            //游戏攻略
            .state('find.yxgl', {
                url: '/yxgl',
                cache: true,
                views: {
                    'find': {
                        templateUrl: 'templates/find/yxgl.html',
                        controller: 'gameraidersCtrl'
                    }
                }
            })

            //查看详细
            .state('find.gamedetail', {
                url: '/gamedetail',
                cache: true,
                views: {
                    'find': {
                        templateUrl: 'templates/find/gamedetail.html',
                        controller: 'gamemoreCtrl'
                    }
                }
            })

            //游戏推荐
            .state('find.yxtj', {
                url: '/yxtj',
                cache: true,
                views: {
                    'find': {
                        templateUrl: 'templates/find/yxtj.html',
                        controller: 'recommendCtrl'
                    }
                }
            })

            .state('mine.txlist', {
                url: '/txlist',
                cache: true,
                views: {
                    'mine': {
                        templateUrl: 'templates/mine/txlist.html',
                        controller: 'txlistCtrl'
                    }
                }
            })

        //设置结束
        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/mine/mine');

    }).directive('hideTabs', function ($rootScope, $location) {
    return {
        restrict: 'AE',
        link: function ($scope) {
            //不想隐藏的时候就不能隐藏了，可以监听$ionicView.beforeEnter
            $rootScope.hideTabs = 'tabs-item-hide';

            $scope.$on('$ionicView.beforeEnter', function () {
                if ($location.path() == '/index/index' || $location.path() == '/cart/cart' || $location.path() == '/mine/mine' || $location.path() == '/set/set') {
                    $rootScope.hideTabs = ' ';
                }
            });

            $scope.$on('$ionicView.beforeLeave', function () {
                if ($location.path() == '/index/index' || $location.path() == '/cart/cart' || $location.path() == '/mine/mine' || $location.path() == '/set/set') {
                    $rootScope.hideTabs = ' ';
                }
            });
        }
    }
}).directive('dir', function ($compile, $parse) {//--ty--20160726
    return {
        restrict: 'EA',
        link: function (scope, element, attr) {
            scope.$watch(attr.content, function () {
                element.html($parse(attr.content)(scope));
                $compile(element.contents())(scope);
            }, true);
        }
    }
}).filter('cut', function () {
    return function (value, wordwise, max, tail) {
        if (!value) return '';

        max = parseInt(max, 10);
        if (!max) return value;
        if (value.length <= max) return value;

        value = value.substr(0, max);
        if (wordwise) {
            var lastspace = value.lastIndexOf(' ');
            if (lastspace != -1) {
                value = value.substr(0, lastspace);
            }
        }

        return value + (tail || '...');
    };
});