var pageSize=30;
var servers=angular.module('starter.services', []);

  servers.service("Common",function($ionicLoading,$state,$ionicModal) {
    this.showLoading = function() {
      $ionicLoading.show({
        content: 'Loading',
        animation: 'fade-in',
        showBackdrop: false,
        showDelay: 0
      });
    };
    this.hideLoading = function() {
      $ionicLoading.hide();
    };
    this.curState = function(){
      return "#/"+$state.current.name.substring(0,$state.current.name.indexOf("."))+"/";
    };
    this.dateFormat=function(date,format) {
      var o = {
        "M+" : date.getMonth()+1, //month
        "d+" : date.getDate(), //day
        "h+" : date.getHours(), //hour
        "m+" : date.getMinutes(), //minute
        "s+" : date.getSeconds(), //second
        "q+" : Math.floor((date.getMonth()+3)/3), //quarter
        "S" : date.getMilliseconds() //millisecond
      };
      if(/(y+)/.test(format)) format=format.replace(RegExp.$1,
        (date.getFullYear()+"").substr(4- RegExp.$1.length));
      for(var k in o)if(new RegExp("("+ k +")").test(format))
        format = format.replace(RegExp.$1,
          RegExp.$1.length==1? o[k] :
            ("00"+ o[k]).substr((""+ o[k]).length));
      return format;
    };
    this.getInterPath = function() {
      if(localStorage.interPath!=undefined) {
        return localStorage.interPath;
      }else {
        localStorage.interPath=domain;
        return localStorage.interPath;
      }
    };
    this.setInterPath = function(path) {
      localStorage.interPath=path;
    };
    this.toLogin=function($scope){
      $ionicModal.fromTemplateUrl("templates/mine/login.html", {
       scope: $scope,
       animation: 'slide-in-up'
       }).then(function(modal) {
       $scope.modal = modal;
       });
       $scope.openModal=function(){
       $scope.modal.show();
       };
       $scope.closeModal=function(){
       $scope.modal.hide();
       }
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // 当隐藏的模型时执行动作
      $scope.$on('modal.hide', function() {
        // 执行动作
      });
      // 当移动模型时执行动作
      $scope.$on('modal.removed', function() {
        // 执行动作
      });
      return $scope.modal;
    }
  })

  .service("Http",function($q,$http,Common,$ionicPopup) {
    this.get = function(url,isHide) {
        var d = $q.defer();
        var promise = d.promise;

        //console.log("请求URL："+url);
        if(typeof isHide=='undefined') {
          isHide=true;
        }
        //console.log(isHide);
        if(isHide){
            Common.showLoading();
        }
        $http.get(url,{timeout:7000})
          .success(function (data) {
            //console.log("响应参数：");
            //console.log(data);
            if(isHide) {
                Common.hideLoading();
            }
            d.resolve(data);
          })
          .error(function (error) {
            if(isHide) {
                Common.hideLoading();
            }
            var alertPopup = $ionicPopup.alert({
              title: '提示',
              template: '数据读取异常',
              buttons:[
                {text:'确认'}
              ]
            });
            alertPopup.then(function(res) {

            });
              d.reject(error);
          });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        };
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        };
        return d.promise;
      };
    this.post=function(url,data,isHide){
      var d = $q.defer();
      var promise = d.promise;

      //console.log("请求URL："+url);
      if(typeof isHide=='undefined') {
        isHide=true;
      }
      if(isHide){
          Common.showLoading();
      }

      //2016.7.12修改
     /* var transform = function(data){
        return $.param(data);
      }
      $http.post(url,data,{
        headers: { 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'},
        transformRequest: transform
      }).*/
      //2016.7.12修改
      //早期版本
      /*$http({
        method:"POST",
        url:url,
        params:data
      }).*/
      //早期版本
      $http.post(url,data,{timeout:7000}).
      success(function (data) {
            //console.log("响应参数：");
            //console.log(data);
            d.resolve(data);
            if(isHide) {
                Common.hideLoading();
            }
          })
          .error(function (error) {
            d.reject(error);
            if(isHide) {
                Common.hideLoading();

                var alertPopup = $ionicPopup.alert({
                  title: '提示',
                  template: '数据读取异常',
                  buttons:[
                    {text:'确认'}
                  ]
                });
                alertPopup.then(function(res) {
                  //console.log('Thank you for not eating my delicious ice cream cone');
                });
            }
          });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return d.promise;
      }
    //
    this.getApiPath=function(){
      var L = basePath;
      return L;
    };
    this.getDomain=function(){
      var L = domain;
      return L;
    };
    this.getServerTimeMilliseconds=function(){
      var url = this.getApiPath() + "getServerTime.jsp";
      var data = {};
      var jsonRet = this.post(url,data,false);
      return jsonRet.milliseconds;
    };
    this.getServerTimeMillisecondsJianNow=function(){
      var sTime = this.getServerTimeMilliseconds();
      var nTime = new Date().getTime();
      var snTime = sTime-nTime;
      return snTime;
    };
    //产品图片路径处理
    this.getHttpOrlocalProPic=function(pic){
      if(pic != null && pic != ""){
        if(pic.indexOf("http://") < 0 && pic.indexOf("https://") < 0){
          pic = domain + pic;
        }
      }else{
        pic = "pro_pic_default.png";
      }
      return pic;
    };
    //用户头像路径处理
    this.getHttpOrlocalHeadPic=function(pic){
      if(pic != null && pic != ""){
        if(pic.indexOf("http://") < 0 && pic.indexOf("https://") < 0){
          pic = domain + pic;
        }
      }else{
        pic = "head_pic_sys.jpg";
      }
      return pic;
    }
  })

  .factory("zkxcService", function($http) {
    return {
      checkLogin: function(backUrl, logUrl,toUrl,$scope) {
        localStorage.removeItem("backUrlLogin");
        var u = localStorage.getItem("uid_local");
        if(u == null || u == "" || typeof(u) == "undefined"){
            //跳转登录
            localStorage.setItem("backUrlLogin",backUrl);//存储登录后的跳转页面
            $scope.openModal();
            return;
        }else{
          //验证账号有效性
          var url = basePath + "UserServlet";
          var dataJson = {'u':u,operation : "checkUser"};
          $http.post(url,dataJson).success(function (subRetJson) {
            var code = subRetJson.code;
            if(code != 200){
                localStorage.setItem("backUrlLogin",backUrl);//存储登录后的跳转页面
                $scope.openModal();
                return;
            }else {
                if(toUrl != null && toUrl != "" && typeof(toUrl) != "undefined"){
                    window.location.href=toUrl;
                }
            }
          });
        }
      }
    };
      }
  )

