/**
 *
 @module Xview服务(类库)
 @class Xview服务(自定义)
 */
servers
  .factory('XviewService', function ($http) {
    return {
      //----------------登录的方法-------------------
      /**
       * 微信登录
       @method loginToWeixin
       @param fun {object} 调起支付后的回调方法
       @since 2.0
      */
      loginToWeixin: function (fun) {
        //调用xview中的方法
        //window.xview.loginToWeixin("callBack");
        this.xviewPhoneWithAppDataWithCallbackMethodWithType({"xview":"WeChat Login"},fun,"1");
      },
      /**
       *  qq登录
       @method loginToTencentQQ
       @param fun {object} 调起支付后的回调方法
       @since 2.0
       */
      loginToTencentQQ:function(fun){
        //调用xview中的方法
        //window.xview.loginToTencentQQ("callBack");
        this.xviewPhoneWithAppDataWithCallbackMethodWithType({"xview":"QQ Login"},fun,"3");
      },
      /**
       * 微博登录
       @method loginToWeibo
       @param fun {object} 调起支付后的回调方法
       @since 2.0
       */
      loginToWeibo:function(fun){
        //调用xview中的方法
        //window.xview.loginToWeibo("callBack");
        this.xviewPhoneWithAppDataWithCallbackMethodWithType({"xview":"Microblog Login"},fun,"2");
      },
      //----------------分享的方法-------------------
      /**
       *  分享给微信朋友
       @method shareToWeixinFriendUrl
       @param data {json} 第三方分享需要的json数据
       @example {"title":"分享标题", "descrption":"分享简介", "picture":"图片地址", "url":"跳转链接地址"}
       @since 2.0
       */
      shareToWeixinFriendUrl:function(data,fun){
        //data=JSON.stringify(data);
        //window.xview.shareToWeixinFriendUrl(data);
        this.xviewPhoneWithAppDataWithCallbackMethodWithType(data,fun,"7");
      },
      /**
       *  分享到微信朋友圈
       @method shareToWeixinCircleUrl
       @param data {json} 第三方分享需要的json数据
       @example {"title":"分享标题", "descrption":"分享简介", "picture":"图片地址", "url":"跳转链接地址"}
       @since 2.0
       */
      shareToWeixinCircleUrl:function(data,fun){
        //data=JSON.stringify(data);
        //window.xview.shareToWeixinCircleUrl(data);
        this.xviewPhoneWithAppDataWithCallbackMethodWithType(data,fun,"8");
      },
      /**
       *  分享到腾讯qq好友
       @method shareToTencentQQUrl
       @param data {json} 第三方分享需要的json数据
       @example {"title":"分享标题", "descrption":"分享简介", "picture":"图片地址", "url":"跳转链接地址"}
       @since 2.0
       */
      shareToTencentQQUrl:function(data,fun){
        //data=JSON.stringify(data);
        //window.xview.shareToTencentQQUrl(data);
        this.xviewPhoneWithAppDataWithCallbackMethodWithType(data,fun,"9");
      },
      /**
       *  分享到腾讯qq空间
       @method shareToTencentQQUrl
       @param data {json} 第三方分享需要的json数据
       @example {"title":"分享标题", "descrption":"分享简介", "picture":"图片地址", "url":"跳转链接地址"}
       @since 2.0
       */
      shareToTencentQQZoneUrl:function(data,fun){
        //data=JSON.stringify(data);
        //window.xview.shareToTencentQQUrl(data);
        this.xviewPhoneWithAppDataWithCallbackMethodWithType(data,fun,"10");
      },
      /**
       *  分享到微博
       @method shareToWeiboUrl
       @param data {json} 第三方分享需要的json数据
       @example {"title":"分享标题", "descrption":"分享简介", "picture":"图片地址", "url":"跳转链接地址"}
       @since 2.0
       */
      shareToWeiboUrl:function(data,fun){
        //data=JSON.stringify(data);
        //window.xview.shareToWeiboUrl(data);
        this.xviewPhoneWithAppDataWithCallbackMethodWithType(data,fun,"11");
      },
      //----------------支付的方法-------------------
      /**
       *  支付宝支付
       @method alipayUrl
       @param data {json} 调起支付宝支付需要的json数据
       @param url {string} 支付宝支付完成后的回调页面地址
       @since 2.0
       */
      alipayUrl:function(data,fun){
        //window.xview.alipayUrl(data,fun);
        var postData={code:data};
        this.xviewPhoneWithAppDataWithCallbackMethodWithType(postData,fun,"4");
      },
      /**
       *  微信支付
       @method wxpayUrl
       @param data {json} 调起微信支付需要的json数据
       @param url {string} 微信支付完成后的回调页面地址
       @since 2.0
       */
      wxpayUrl:function(data,fun){
        //window.xview.wxpayUrl(JSON.stringify(data),url);
        this.xviewPhoneWithAppDataWithCallbackMethodWithType(data,fun,"5");
      },
      /**
       *  连连支付
       @method llpayUrl
       @param data {json} 调起连连支付需要的json数据
       @param url {string} 连连支付完成后的回调页面地址
       @since 2.0
       */
      llpayUrl:function(data,fun){
        //连连比较特殊，需要将前端不需要，app需要的参数拼接进去
        var timestamp="201602020202020";
        data["frms_ware_category"]="";
        data["frms_ware_category"]="2009";
        data["user_info_mercht_userno"]=data.user_id;
        data["user_info_dt_register"]= '20160630205937';
        data["user_info_id_no"]= data.id_no;
        data["user_info_identify_type"]="3";
        data["user_info_identify_state"]="1";
        data["user_info_bind_phone"]= data.user_id;
        data["dt_order"]=timestamp+""; //商户订单时间
        data["oid_partner"]="201408071000001543"; //商户编号
        data["sign_type"]="MD5"; //签名方式
        data["sign"]="201408071000001543test_20140812"; //签名
        data["busi_partner"]="101001"; //商户业务类型:虚拟:101001;实物:109001
        //var t={"no_order":"DL20160630205937","money_order":"0.01","user_id":"123456","id_type":"0","notify_url":"http://xview1.com28.cn/pay_return/notify_llpay.jsp","id_no":"321111199403011611","acct_name":"刘恂","card_no":"6212264301001051596","name_goods":"测试产品         ","frms_ware_category":"2009","user_info_mercht_userno":"123456","user_info_dt_register":"20160630205937","user_info_id_no":"321111199403011611","user_info_identify_type":"3","user_info_identify_state":"1","user_info_bind_phone":"123456","dt_order":"20160630205937","oid_partner":"201408071000001543","sign_type":"MD5","sign":"201408071000001543test_20140812","busi_partner":"101001"}
        //var c={"no_order":"D146729114200040","money_order":"0.01","user_id":"123456","id_type":"0","notify_url":"http://xview1.com28.cn/pay_return/notify_llpay.jsp","id_no":"321111199403011611","acct_name":"刘恂","card_no":"6212264301001051596","name_goods":"夏恒网络XVIEW测试","frms_ware_category":"2009","user_info_mercht_userno":"123456","user_info_dt_register":"20160630205937","user_info_id_no":"321111199403011611","user_info_identify_type":"3","user_info_identify_state":"1","user_info_bind_phone":"123456","dt_order":"1467291561000","oid_partner":"201408071000001543","sign_type":"MD5","sign":"201408071000001543test_20140812","busi_partner":"101001"};
        //alert(JSON.stringify(data));
        //window.xview.llpayUrl(JSON.stringify(data),url);
        this.xviewPhoneWithAppDataWithCallbackMethodWithType(data,fun,"6");
      },
      //----------------微信，qq，微博及连连统一接口-------------------
      /**
       *  微信，qq，微博及连连整合方法 (一般不用直接调用，不过也提供一个函数)
       @method xviewPhoneWithAppDataWithCallbackMethodWithType
       @param data {json} 需要的json数据
       @param fun {string} 回调函数名
       @param typeString {string} 类型
               1-微信登陆 2-微博登陆 3-QQ登陆
               4-支付宝支付 5-微信支付 6-连连支付
               7-分享给微信好友 8-微信朋友圈
               9-分享给QQ好友  10-分享到QQ空间  11-分享到微博
       @since 2.0
       */
      xviewPhoneWithAppDataWithCallbackMethodWithType:function(data,fun,typeString){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.xviewPhoneWithAppDataWithCallbackMethodWithType(JSON.stringify(data),"callBack",typeString);
      },
      //----------------地图，定位，扫描二维码，摇一摇方法-------------------
      /**
       *  地理定位，获取当前位置
       @method geographyLocationCallbackMethod
       @param fun  {function} 获取位置之后的回调函数
       @since 2.0
       */
      geographyLocationCallbackMethod:function(fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.geographyLocationCallbackMethod("callBack");
      },
      /**
       *  调起高德地图
       @method aMapNavigationCallbackMethod
       @param fun  {function} 调起高德地图之后的回调方法
       @since 2.0
       */
      aMapNavigationCallbackMethod:function(fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.aMapNavigationCallbackMethod("callBack");
      },
      /**
       *  扫描二维码
       @method scanBarcodeCallbackMethod
       @param fun  {function} 扫描之后的回调函数
       @since 2.0
       */
      scanBarcodeCallbackMethod:function(fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.scanBarcodeCallbackMethod("callBack");
      },
      /**
       *  摇一摇
       @method shakeCallbackMethod
       @param url  {string} 业务逻辑接口地址
       @param fun  {function} 摇一摇之后的回调函数
       @since 2.0
       */
      shakeCallbackMethod:function(url,fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.shakeCallbackMethod(url,"callBack");
      },
      //----------------视频，音频方法-------------------
      /**
       *  开始录音
       @method recorderStartCallbackMethod
       @param fileName  {string} 文件名
       @param fun  {function} 扫描之后的回调函数
       @since 2.0
       */
      recorderStartCallbackMethod:function(fileName,fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.recorderStartCallbackMethod(fileName,"callBack");
      },
      /**
       *  结束录音
       @method recorderEnd
       @since 2.0
       */
      recorderEnd:function(){
        window.xview.recorderEnd();
      },
      /**
       *  播放本地的音频
       @method playLocationAudioCallbackMethod
       @param fileName {string} 音频文件名称
       @param fun {function} 播放后的回调方法
       @since 2.0
       */
      playLocationAudioCallbackMethod:function(fileName,fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.playLocationAudioCallbackMethod(fileName,"callBack");
      },
      /**
       *  播放网络的音频
       @method playNetworkAudioCallbackMethod
       @param path {string} 网络音频文件地址
       @param fun {function} 播放后的回调方法
       @since 2.0
       */
      playNetworkAudioCallbackMethod:function(path ,fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.playNetworkAudioCallbackMethod(path,"callBack");
      },
      /**
       *  停止播放音频
       @method stopPlayAudioCallbackMethod
       @param fun {function} 播放后的回调方法
       @since 2.0
       */
      stopPlayAudioCallbackMethod:function(fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.stopPlayAudioCallbackMethod("callBack");
      },
      //----------------拍照，摄像相关方法-------------------
      /**
       *  拍照
       @method takePhotoCallbackMethod
       @param filename {string} 照片文件名
       @param fun {function} 拍照后的回调方法
       @since 2.0
       */
      takePhotoCallbackMethod:function(filename,fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.takePhotoCallbackMethod(filename,"callBack");
      },
      /**
       *  查看本地照片
       @method playPhotoCallbackMethod
       @param path {string} 照片路径
       @param fun {function} 选择之后的回调
       @since 2.0
       */
      playPhotoCallbackMethod:function(path,fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.playPhotoCallbackMethod(path,"callBack");
      },
      /**
       *  录制视频
       @method recorderVideoCallbackMethod
       @param path {string} 视频路径
       @param fun {function} 录制后的回调
       @since 2.0
       */
      recorderVideoCallbackMethod:function(path,fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.recorderVideoCallbackMethod(path,"callBack");
      },
      /**
       *  播放本地视频
       @method playLocationVideoCallbackMethod
       @param path {string} 视频路径
       @param fun {function} 录制后的回调
       @since 2.0
       */
      playLocationVideoCallbackMethod:function(path,fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.playLocationVideoCallbackMethod(path,"callBack");
      },
      /**
       *  播放网络视频
       @method playNetworkVideoCallbackMethod
       @param path {string} 视频路径
       @param fun {function} 录制后的回调
       @since 2.0
       */
      playNetworkVideoCallbackMethod:function(path,fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.playNetworkVideoCallbackMethod(path,"callBack");
      },
      //----------------多选图片-------------------
      /**
       *  多选图片
       @method chooseImageCallbackMethod
       @param numberString {string} 图片数量
       @param fun {function} 选择之后的回调
       @since 2.0
       */
      chooseImageCallbackMethod:function(numberString,fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.chooseImageCallbackMethod(numberString,"callBack");
      },
      //----------------下载文件，预览pdf-------------------
      /**
       *  下载文件
       @method downloadFileCallbackMethod
       @param path {string} 文件网址
       @param fun {function} 选择之后的回调
       @since 2.0
       */
      downloadFileCallbackMethod:function(path,fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.downloadFileCallbackMethod(path,"callBack");
      },
      //----------------设备信息-------------------
      /**
       *  获取设备信息
       @method getDeviceInfoCallbackMethod
       @param fun {function} 获取之后的回调
       @since 2.0
       */
      getDeviceInfoCallbackMethod:function(fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.getDeviceInfoCallbackMethod("callBack");
      },
      /**
       *  获取系统信息
       @method getSystemInfoCallbackMethod
       @param fun {function} 获取之后的回调
       @since 2.0
       */
      getSystemInfoCallbackMethod:function(fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.getSystemInfoCallbackMethod("callBack");
      },
      /**
       *  蜂鸣
       @method phoneBuzzingCallbackMethod
       @param fun {function} 回调函数
       @since 2.0
       */
      phoneBuzzingCallbackMethod:function(fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.phoneBuzzingCallbackMethod("callBack");
      },
      /**
       *  震动
       @method phoneShockCallbackMethod
       @param fun {function} 回调方法
       @since 2.0
       */
      phoneShockCallbackMethod:function(fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.phoneShockCallbackMethod("callBack");
      },
      /**
       *  拨打手机号码
       @method phoneCallTelphoneCallbackMethod
       @param phone {string} 手机号码
       @param fun {function} 获取之后的回调
       @since 2.0
       */
      phoneCallTelphoneCallbackMethod:function(phone,fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.phoneCallTelphoneCallbackMethod(phone,"callBack");
      },
      //----------------图形解锁-------------------
      /**
       * 图形解锁
       @method graphicsUnlockCallbackMethod
       @param fun {function} 每次触发解锁的回调
       @since 2.0
       */
      graphicsUnlockCallbackMethod:function(fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.graphicsUnlockCallbackMethod("callBack");
      },
      //----------------原生UI-------------------
      /**
       * 原生弹框
       @method showiPhoneAlertWithAppDataTypeWithCallbackMethod
       @param data {function} 展示的数据
       {"title":"", "message":"", "button","["取消", "确定", "...", "..."]"}
       @param type {function} 类型
        alert->alert，
        input->input,
        actionsheet->ActionSheet，
        time->时间选择器，
        date->日期选择器
        disappear->自动消失的提示框设了3秒
        wait->转圈的，现在设了5秒
       @param fun {function} 回调方法
       @since 2.0
       */
      showiPhoneAlertWithAppDataTypeWithCallbackMethod:function(dataString,typeString,fun){
        window.callBack=function(result){
          fun(result);
        };
        window.xview.showiPhoneAlertWithAppDataTypeWithCallbackMethod(dataString,typeString,"callBack");
      },
      /**
       * 跳转浏览器（打开app）
       @method openiPhoneApp
       @param url {function} 需要打开的网址或者app的App URL scheme
       @since 2.0
       */
      openiPhoneApp:function(url){
        window.xview.openiPhoneApp(url);
      }

    };
  })
