(function () {
  'use strict';
  angular.module('XviewPlugin', [])
    .service('numberBoxService', function () {
      var _this = this;
      //页面中选择器数量 default : 0
      _this.globalId = 0;
      return _this;
    })
    /*日期时间选择*/
    .directive('numberBox', [
      'numberBoxService',
      function () {
        return {
          template:'<div class="mui-numbox">'+
                    '<button class="mui-btn mui-btn-numbox-minus" type="button" ng-click="addNumber(-1)">-</button>'+
                    '<input class="mui-input-numbox" type="number" ng-model="numberBox.number" />'+
                    '<button class="mui-btn mui-btn-numbox-plus" type="button" ng-click="addNumber(1)">+</button>'+
                    '</div>',
          /*templateUrl:"lib/numberbox/template.html",*/
          restrict: 'AE',
          replace: true,
          scope: {
            numberBoxValue:"="//双向绑定
          },
          link: function (scope, elm, attrs) {
            //console.log(attrs);
            scope.numberBox={number:1,maxNumber:999999999,minNumber:-999999999,baseNumber:1}
            if(typeof attrs.initNumber != 'undefined'){
              scope.numberBox.number=parseInt(attrs.initNumber);
            }
            if(typeof attrs.maxNumber != 'undefined'){
              scope.numberBox.maxNumber=parseInt(attrs.maxNumber);
            }
            if(typeof attrs.minNumber != 'undefined'){
              scope.numberBox.minNumber=parseInt(attrs.minNumber);
            }
            if(typeof attrs.baseNumber != 'undefined'){
              var t=parseInt(attrs.baseNumber)
              if(t<=0){
                t=1;
              }
              scope.numberBox.baseNumber=t;
            }
            //点击事件（加和减）
            scope.addNumber=function(num){
              if(scope.numberBox.number==scope.numberBox.minNumber){
                num*scope.numberBox.baseNumber>0 ? scope.numberBox.number+=num*scope.numberBox.baseNumber :scope.numberBox.number;
              }else if(scope.numberBox.number==scope.numberBox.maxNumber){
                num*scope.numberBox.baseNumber<0 ? scope.numberBox.number+=num*scope.numberBox.baseNumber :scope.numberBox.number;
              }else{
                scope.numberBox.number+=num*scope.numberBox.baseNumber
              }
              scope.numberBoxValue=scope.numberBox.number;
            }

            scope.$watch("numberBox.number",function(){
              if(typeof scope.numberBox.number=='undefined'){
                scope.numberBox.number=scope.numberBoxValue;
              }
              scope.numberBox.number=parseInt(scope.numberBox.number);
              if(scope.numberBox.number>scope.numberBox.maxNumber){
                scope.numberBox.number=scope.numberBox.maxNumber;
              }
              if(scope.numberBox.number<scope.numberBox.minNumber){
                scope.numberBox.number=scope.numberBox.minNumber;
              }
              scope.numberBoxValue=scope.numberBox.number;
            });
          }
        }
      }
    ]);
})(window, document);
